import functools
import logging
import os
import zlib

from redis_cache import RedisCache

try:
    import cPickle as pickle
except:
    import pickle
from api import request_cache

# TODO: use MockCache if in local server
CACHE_CLASS = RedisCache

# service_cache provides an easy way to cache the result of functions across requests.
#
#
# _____Explanation by examples:_____
#
# Cache the result of
# this long-running function using a static key,
# and return the result when available instead of recalculating:
#
#     import service_cache
#
#     @service_cache.cache()
#     def calculate_user_averages():
#        ...do lots of long-running work...
#        return result_for_cache
#
# and with expiration every minute:
#
#     @service_cache.cache(expiration=60)
#     def calculate_user_averages():
#        ...do lots of long-running work...
#        return result_for_cache
#
# Cache using key generated by utility function that
# varies the key based on the function's input parameters:
#
#     @service_cache.cache_with_key_fxn(lambda object: "cache_key_for_object_%s" % object.id())
#     def calculate_object_average(object):
#       ... do lots of long-running work...
#       return result_for_cache
#
#
# _____Manually busting the cache:_____
#
# When you call your cached function, just pass a special "bust_cache"
# named parameter to ignore any existing cached values and replace
# with whatever is newly returned:
#
#     calculate_object_average(object, bust_cache=True)
#
#
# _____Other settings/options:_____
#
# Persist the cached values across different uploaded app verions (disabled by default):
#     @service_cache.cache(... persist_across_app_versions=True)
#
# If key has expired or is no longer in the current cache and throws an error
# when trying to be recomputed, then try getting resource from permanent key
# that is not set to expire
#     @service_cache.cache(... expiration=60, permanent_cache_key =
#       lambda object: "permanent_service_cache_key_for_object_%s" % object.id())
#
# If you know that a function will always return something bigger than 1MB, you
# can set this parameter to not bother attempting to set it normally as you know
# it will fail, hence will save 1RPC:
#     @service_cache.cache(... use_chunks=True)
#
# If you know a function will return something that is > 1MB and won't compress
# easily to something much smaller, you can set this value to False to save on
# compression and decompression time
#     @service_cache.cache(... compress_chunks=False)
#
#
# _____Disabling:_____
#
# You can disable service_cache for the rest of the request by calling:
# service_cache.disable()
#
# Re-enable it with
# service_cache.enable()

from base_cache import MAX_SIZE_OF_CACHE_CHUNKS

# memory cache has 32MB limit for set_multi (this is 32MB - ChunkedResult overhead)
MAX_SIZE = 33 * 1000 * 1000

# a random string of this length is prepended to each chunk for values that
# need to be chunked
CHUNK_GENERATION_LENGTH = 16

# Expire after 25 days by default
DEFAULT_SERVICE_CACHE_EXPIRATION_SECONDS = 60 * 60 * 24 * 25


def disable():
    request_cache.set_cache("service_cache_disabled", True)


def enable():
    request_cache.set_cache("service_cache_disabled", False)


def is_disabled():
    return request_cache.get_cache("service_cache_disabled") or False


def cache(
        expiration=DEFAULT_SERVICE_CACHE_EXPIRATION_SECONDS,
        persist_across_app_versions=False,
        use_chunks=False,
        compress_chunks=True):
    def decorator(target):
        key = "__service_cache_%s.%s__" % (target.__module__, target.__name__)

        @functools.wraps(target)
        def wrapper(*args, **kwargs):
            return service_cache_check_set_return(target,
                                                  lambda *args, **kwargs: key, expiration,
                                                  persist_across_app_versions, None, use_chunks,
                                                  compress_chunks, *args, **kwargs)

        return wrapper

    return decorator


def cache_with_key_fxn(
        key_fxn,
        expiration=DEFAULT_SERVICE_CACHE_EXPIRATION_SECONDS,
        persist_across_app_versions=False,
        permanent_key_fxn=None,
        use_chunks=False,
        compress_chunks=True):
    def decorator(target):
        @functools.wraps(target)
        def wrapper(*args, **kwargs):
            return service_cache_check_set_return(
                target, key_fxn, expiration,
                persist_across_app_versions, permanent_key_fxn,
                use_chunks, compress_chunks, *args, **kwargs
            )

        return wrapper

    return decorator


def service_cache_check_set_return(
        target,
        key_fxn,
        expiration=DEFAULT_SERVICE_CACHE_EXPIRATION_SECONDS,
        persist_across_app_versions=False,
        permanent_key_fxn=None,
        use_chunks=False,
        compress_chunks=True,
        *args,
        **kwargs):
    def get_cached_result(key, namespace):
        maybe_chunked_result = CACHE_CLASS.get(key, namespace=namespace)
        if maybe_chunked_result is not None:
            if isinstance(maybe_chunked_result, ChunkedResult):
                result = maybe_chunked_result.get_result(CACHE_CLASS,
                                                         namespace=namespace)
            else:
                result = maybe_chunked_result

            return result

    def set_cached_result(key, namespace, expiration, result,
                          use_chunks, compress_chunks):
        # Cache the result
        if not use_chunks:

            try:
                if not CACHE_CLASS.set(key, result, time=expiration,
                                       namespace=namespace):
                    logging.error("Cache set failed for %s", key)
            except ValueError as e:
                if str(e).startswith("Values may not be more than"):
                    # The result was too big to store in cache.  Going
                    # to chunk it and try again
                    ChunkedResult.set(key, result, expiration, namespace,
                                      compress=compress_chunks,
                                      cache_class=CACHE_CLASS)
                else:
                    raise

        else:
            # use_chunks parameter was explicitly set, not going to even
            # bother trying to put it in cache directly
            ChunkedResult.set(key, result, expiration, namespace,
                              compress=compress_chunks,
                              cache_class=CACHE_CLASS)

    bust_cache = False
    if "bust_cache" in kwargs:
        bust_cache = kwargs["bust_cache"]
        # delete from kwargs so it's not passed to the target
        del kwargs["bust_cache"]

    key = key_fxn(*args, **kwargs)

    # if key is None, or service_cache is disabled don't bother trying to get it
    # from the cache, just execute the function and return it
    if key is None or request_cache.get_cache("service_cache_disabled"):
        return target(*args, **kwargs)

    namespace = os.environ.get('CURRENT_VERSION_ID')

    if persist_across_app_versions:
        namespace = None

    if not bust_cache:
        result = get_cached_result(key, namespace)
        if result is not None:
            return result

    try:
        result = target(*args, **kwargs)

    # an error happened trying to recompute the result, see if there is a value for it in the permanent cache
    except Exception as e:
        if permanent_key_fxn is not None:
            permanent_key = permanent_key_fxn(*args, **kwargs)

            result = get_cached_result(permanent_key, namespace)

            if result is not None:
                logging.info("resource is not available, restoring from permanent cache")

                # In case the key's value has been changed by target's execution
                key = key_fxn(*args, **kwargs)

                # retreived item from permanent cache - save it to the more temporary cache and then return it
                set_cached_result(key, namespace, expiration, result,
                                  use_chunks, compress_chunks)
                return result

        # could not retrieve item from a permanent cache, raise the error on up
        logging.exception(e)
        raise

    if permanent_key_fxn is not None:
        permanent_key = permanent_key_fxn(*args, **kwargs)
        set_cached_result(permanent_key, namespace, 0, result,
                          use_chunks, compress_chunks)

    # In case the key's value has been changed by target's execution
    key = key_fxn(*args, **kwargs)
    set_cached_result(key, namespace, expiration, result,
                      use_chunks, compress_chunks)

    return result


def flush():
    CACHE_CLASS.flush()


class ChunkedResult():
    ''' Allows for storing of data between 1MB and 32MB in size.  If compression
    is turned on then it will first compress the result and store it in this
    object with data set, if it is now under 1MB, otherwise if after compression
    or if compression is turned off it will do a set_multi to store the result
    in chunks.
    '''

    def __init__(self,
                 chunk_list=None,
                 generation=None,
                 data=None,
                 compress=True):
        ''' Stores info on the data to be stored. Either chunk_list+generation
        or data is set, but not both

        Arguments:
            chunk_list: listing out the keys of the chunks that store the data
            generation: a random string that gets prepend to all chunks to make
                        sure that they are all from the same set
            data:  for the case in which the compressed value could fit in a
                   single chunk, then data will store the compressed result
            compress: boolean saying whether we should compress the result
                      before storing and decompressing afterwards
        '''
        assert (bool(chunk_list and generation) ^ bool(data)), ("Either "
                                                                "chunk_list+generation or data must be set, but not both")
        if chunk_list:
            self.chunk_list = chunk_list
            self.generation = generation
        else:
            self.data = data
        self.compress = compress

    def __len__(self):
        return len(self.data) if self.data else 0

    @staticmethod
    def set(key, value, time=None, namespace="", cache_class=CACHE_CLASS,
            compress=True):
        ''' This function will pickle and perhaps compress value, before then
        breaking it up into 1MB chunks and storing it with set_multi to whatever
        class cache_class is set to
        '''

        result = pickle.dumps(value)
        if compress:
            result = zlib.compress(result)

        size = len(result)
        if size > MAX_SIZE:
            logging.error("Not caching %s: %i is greater than maxsize %i",
                          key, size, MAX_SIZE)
            return

        # if now that we have compressed the item it can fit within a single
        # 1MB object don't use the chunk_list, and it will save us from having
        # to do an extra round-trip on the gets
        if size < MAX_SIZE_OF_CACHE_CHUNKS:
            return cache_class.set(key,
                                   ChunkedResult(data=result,
                                                 compress=compress),
                                   time=time,
                                   namespace=namespace)

        mapping = {}
        chunk_list = []
        generation = os.urandom(CHUNK_GENERATION_LENGTH)
        for i, pos in enumerate(range(0, size, MAX_SIZE_OF_CACHE_CHUNKS)):
            chunk = generation + result[pos: pos + MAX_SIZE_OF_CACHE_CHUNKS]
            chunk_key = key + "__chunk%i__" % i
            mapping[chunk_key] = chunk
            chunk_list.append(chunk_key)

        mapping[key] = ChunkedResult(chunk_list=chunk_list,
                                     generation=generation,
                                     compress=compress)

        # Note: set_multi is not atomic so when we get we will need to make sure
        # that all the keys are there and are part of the same set_multi
        # operation
        return cache_class.set_multi(mapping, time=time, namespace=namespace)

    @staticmethod
    def delete(key, namespace="", cache_class=CACHE_CLASS):
        '''This function will first get the key.  If it is a ChunkedResult and
        has an chunk_list, then it will delete_multi on all the items in that
        list otherwise it will just delete the key'''
        value = cache_class.get(key, namespace)
        if isinstance(value, ChunkedResult) and hasattr(value, "chunk_list"):
            keys = value.chunk_list
            keys.append(key)
            cache_class.delete_multi(keys, namespace=namespace)
        elif value is not None:
            cache_class.delete(key, namespace=namespace)

    def get_result(self, cache_class=CACHE_CLASS, namespace=""):
        '''If the results are stored within this ChunkedResult object it will
        decompress, depickle and return it.  Otherwise it calls get_multi on the
        cache_class for all items in its chunk_list, combines them together and
        returns the descompressed and depickled result
        '''
        if hasattr(self, "chunk_list"):
            chunked_results = cache_class.get_multi(self.chunk_list,
                                                    namespace=namespace)
            self.data = bytes()
            for chunk_key in self.chunk_list:
                if chunk_key not in chunked_results:
                    # if a chunk is missing then it is impossible to depickle
                    # so target func will need to be re-executed
                    return None

                # It is possible that the results come some from a new value of
                # a cached item and some from an old version of the cached item
                # as set_multi is not atomic.  By adding a random generation
                # string to the beginning of each chunk we can be sure they are
                # all part of the same set, by checking if that string matches
                # the one in the index
                chunk_result = chunked_results[chunk_key]
                chunk_generation = chunk_result[:CHUNK_GENERATION_LENGTH]
                if chunk_generation != self.generation:
                    logging.warning("invalid chunk: wrong generation string"
                                    " in chunk %s", chunk_key)
                    return None

                self.data += chunk_result[CHUNK_GENERATION_LENGTH:]

        if self.compress:
            try:
                self.data = zlib.decompress(self.data)
            except zlib.error:
                # If for some reason the data coming back is corrupted so it
                # can't be decompressed, we return None in order to recaclulate
                # the target function
                logging.warning("could not decompress ChunkedResult from cache")
                return None

        try:
            return pickle.loads(self.data)
        except Exception:
            # If for some reason the data coming back is corrupted so it can't
            # be depickled, we will return None in order to recaclulate the
            # target function
            logging.warning("could not depickle ChunkedResult from cache")
            return None
